Change Suggests: line into Recommends: and added mdadm.
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Sam Mär 17 23:52:56 CET 2007 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus16'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
265    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
266    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
268    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
269  fi
270
271  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
272
273   # Set default keyboard before interactive setup
274   if [ -n "$KEYTABLE" ] ; then
275    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
276    loadkeys -q $KEYTABLE &
277    eend $?
278   fi
279
280   if [ -n "$CONSOLEFONT" ] ; then
281      einfo "Running consolechars using ${CONSOLEFONT}"
282      consolechars -f $CONSOLEFONT || consolechars -d
283      eend $?
284   fi
285
286   # we have to set up all consoles, therefore loop it over all ttys:
287   if [ -n "$CHARMAP" ] ; then
288      einfo "Running consolechars for ${CHARMAP}"
289      NUM_CONSOLES=`fgconsole --next-available`
290      NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
291      [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
292      for vc in `seq 0 ${NUM_CONSOLES}`  ; do
293        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
294      done
295      eend ${RC}
296   fi
297
298   # activate unicode console if running within utf8 environment
299   if [ -r /etc/default/locale ] ; then
300      if grep -q "LANG=.*UTF" /etc/default/locale ; then
301         einfo "Setting up unicode environment."
302         unicode_start
303         eend $?
304      fi
305   fi
306
307  eoutdent
308 }
309 # }}}
310
311 # {{{ Set hostname
312 config_hostname(){
313  if checkbootparam hostname ; then
314   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
315   einfo "Setting hostname to $HOSTNAME as requested."
316   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
317   hostname $HOSTNAME ; eend $?
318  else
319   hostname --file /etc/hostname
320  fi
321 }
322 # }}}
323
324 # fstabuser (needed when running from harddisk with username != grml {{{
325 config_userfstab(){
326   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
327   if [ -n "$CONFIG_FSTAB_USER" ] ; then
328      fstabuser="$CONFIG_FSTAB_USER"
329   else
330      fstabuser=$(getent passwd 1000 | cut -d: -f1)
331   fi
332   # if not yet set fall back to default 'grml' user
333   [ -n "$fstabuser" ] || fstabuser='grml'
334 }
335 # }}}
336
337 # {{{ Set clock (Local time is more often used than GMT, so it is default)
338 config_time(){
339  # don't touch the files if running from harddisk:
340  if [ -z "$INSTALLED" ]; then
341   UTC=""
342   checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
343   checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
344   # hwclock uses the TZ variable
345   if [ -r /etc/default/locale ] ; then
346      . /etc/default/locale
347   else
348      TZ=Europe/Vienna
349   fi
350   ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1) ; RC=$?
351   if [ -n "$ERROR" ] ; then
352      eindent
353      ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1)
354      if [ -n "$ERROR" ] ; then
355         eerror "Problem running hwclock: $ERROR" ; eend 1
356      fi
357      eoutdent
358   fi
359  fi
360 }
361 # }}}
362
363 # {{{ print kernel info
364 config_kernel(){
365   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
366   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
367   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
368   if [ -r /proc/cpuinfo ] ; then
369      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
370        eindent
371        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
372        eoutdent
373      fi
374   fi
375   if [ -d /proc/xen ] ; then
376      eindent
377      einfo 'Running kernel featuring support for Xen detected' ; eend 0
378      eoutdent
379   fi
380 }
381 # }}}
382
383 # {{{ vmware specific stuff
384 config_vmware(){
385 if checkbootparam novmware ; then
386  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
387 else
388  if [ -z "$INSTALLED" ]; then
389   if vmware-detect ; then
390     if [ -r /etc/X11/xorg.conf.vmware ] ; then
391       einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
392       cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
393     fi
394   fi
395  fi
396 fi
397 }
398 # }}}
399
400 # {{{ ld.so.cache + depmod
401 config_ld_mod(){
402 if [ -n "$INSTALLED" ]; then
403  if ! [ -r /etc/grml.first.boot ] ; then
404   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
405   eindent
406 # Regenerate ld.so.cache and module dependencies on HD
407     einfo "Running ldconfig" ; ldconfig  ; eend $?
408     einfo "Running depmod"   ; depmod -a ; eend $?
409     touch /etc/grml.first.boot
410     eend 0
411   eoutdent
412  fi
413 fi
414 }
415 # }}}
416
417 # update_progress {{{
418 update_progress(){
419   # be sure we are non-blocking
420   (echo "$1" > /etc/sysconfig/progress) &
421 }
422 # }}}
423
424 # {{{ timezone
425 config_timezone(){
426  # don't touch the files if running from harddisk:
427  if [ -z "$INSTALLED" ]; then
428   einfo "Setting timezone."
429   KTZ="$(getbootparam tz 2>>$DEBUG)"
430   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
431   rm -f /etc/localtime
432   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
433  fi
434 }
435 # }}}
436
437 # small computer / nearly no ram {{{
438 config_small(){
439
440 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
441 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
442 eindent
443
444 if checkbootparam "small"; then
445   einfo "Information: ${RAM} kB of RAM available." ; eend 0
446   einfo "Bootoption small detected. Activating small system."
447   if [ -r /etc/inittab.small ] ; then
448     mv /etc/inittab /etc/inittab.normal
449     mv /etc/inittab.small /etc/inittab
450   else
451     sed -i 's/^9/#&/' /etc/inittab
452     sed -i 's/^10/#&/' /etc/inittab
453     sed -i 's/^11/#&/' /etc/inittab
454     sed -i 's/^12/#&/' /etc/inittab
455   fi
456   /sbin/telinit q ; eend $?
457 else
458   if checkgrmlsmall ; then
459     if [[ $RAM -lt 25000 ]] ; then
460       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
461       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
462       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
463       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
464       /bin/zsh --login
465     else
466       einfo "Information: ${RAM} kB of RAM available." ; eend 0
467     fi
468   else
469     if [[ $RAM -lt 58000 ]] ; then
470       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
471       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
472       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
473       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
474       /bin/zsh --login
475     else
476       einfo "Information: ${RAM} kB of RAM available." ; eend 0
477     fi
478   fi
479 fi
480 eoutdent
481 }
482 # }}}
483
484 # skip startup of w3m {{{
485 config_fast(){
486 if checkbootparam "fast"; then
487   ewarn "Bootoption fast detected. Skipping startup of w3m."
488     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
489   /sbin/telinit q ; eend $?
490 fi
491 }
492 # }}}
493
494 # activate serial console {{{
495 config_console(){
496 if checkbootparam "console"; then
497   einfo "Bootoption (for serial) console detected. Activating mgetty."
498     sed -i 's/^#T0/T0/' /etc/inittab
499     sed -i 's/^#T1/T1/' /etc/inittab
500   /sbin/telinit q ; eend $?
501 fi
502 }
503 # }}}
504
505 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
506 config_cdrom_perm(){
507 CDROMS=""
508 for DEVICE in /proc/ide/hd?; do
509  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
510 done
511 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
512 }
513 # }}}
514
515 # {{{ Bring up loopback interface now
516 config_local_net(){
517  if [ -z "$INSTALLED" ] ; then
518     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
519        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
520     else
521        ifconfig lo up
522     fi
523  fi
524 }
525 # }}}
526
527 # firewire devices {{{
528 # the raw1394 driver does not yet export info into SYSFS,
529 # so let's create raw1394 device manually
530 # http://www.michael-prokop.at/blog/index.php?p=352
531 config_firewire_dev(){
532 if checkbootparam "nofirewiredev" ; then
533   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
534 else
535 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
536   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
537 #  cd /dev && MAKEDEV video1394 raw1394
538   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
539   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
540 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
541   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
542   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
543   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
544 fi
545 #fi
546 }
547 # }}}
548
549 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
550 # otherwise we will get: passwd: Authentication token lock busy
551 config_fix_passwd(){
552  if [ -z "$INSTALLED" ] ; then
553   touch /etc/.pwd.lock
554  fi
555 }
556 # }}}
557
558 # {{{ CD Checker
559 config_testcd(){
560 if [ -n "$TESTCD" ]; then
561   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
562   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
563   echo -n "${RED}"
564   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
565   if [ "$?" = "0" ]; then
566     echo " ${GREEN}Everything looks OK${NORMAL}"
567     else
568     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
569     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
570     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
571     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
572     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
573     read a
574   fi
575   eend 0
576 fi
577 }
578 # }}}
579
580 # {{{ hardware detection via discover
581 config_discover(){
582 if checkbootparam "nodisc" ; then
583   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
584 else
585  if [ -x /sbin/discover ] ; then
586   einfo "Discovering hardware. Trying to load the following modules in background:"
587    eindent
588    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
589    eoutdent
590   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
591   eend 0
592  else
593   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
594  fi
595 fi
596 }
597 # }}}
598
599 # {{{ hardware detection via hwinfo
600 config_hwinfo(){
601 if checkbootparam hwinfo >>$DEBUG 2>&1; then
602   einfo "Discovering hardware via hwinfo:"
603   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
604   echo -n "  Loading modules: "
605   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
606   eend 0
607 fi
608 }
609 # }}}
610
611 # {{{ disable hotplug agents on request
612 config_hotplug_agent(){
613 if checkbootparam "noagent" ; then
614   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
615   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
616   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
617   einfo "Disabling hotplug-agent(s) $AGENTNL"
618   for agent in $(echo -e $AGENTLIST) ; do
619     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
620   done
621   [ "$?" == "0" ] ; eend $?
622 fi
623 }
624 # }}}
625
626 # {{{ blacklist of hotplug-modules
627 config_hotplug_blacklist(){
628 if checkbootparam "black" ; then
629   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
630   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
631   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
632   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
633   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
634   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
635   eend 0
636 fi
637 }
638 # }}}
639
640 # {{{ run hotplug
641 config_hotplug(){
642 if checkbootparam "nohotplug" ; then
643   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
644 else
645   if [ -r /etc/init.d/hotplug ] ; then
646     einfo "Starting hotplug system in background."
647     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
648     eend 0
649   elif [ -r /etc/init.d/hotplug-light ] ; then
650     einfo "Starting hotplug-light system in background."
651     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
652     eend 0
653   else
654     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
655   fi
656 fi
657 }
658 # }}}
659
660 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
661 config_blacklist(){
662 if checkbootparam "blacklist" ; then
663  if [ -z "$INSTALLED" ]; then
664   einfo "Bootoption blacklist found."
665   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
666   if [ -n "$BLACK" ] ; then
667     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
668     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
669     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
670     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
671     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
672   else
673    eerror "No given module for blacklist found. Blacklisting will not work therefor."
674   fi
675  else
676   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
677   eindent
678    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
679   eoutdent
680  fi
681 fi
682 }
683 # }}}
684
685 # {{{ ACPI
686 config_acpi_apm(){
687 if [ -d /proc/acpi ]; then
688   if checkbootparam "noacpi"; then
689     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
690   else
691     einfo "ACPI Bios found, activating modules: "
692     eindent
693     found=""
694     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
695       basename="${a##*/}"
696       basename="${basename%%.*}"
697       case "$basename" in *_acpi)
698        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
699       esac
700       modprobe $basename >>$DEBUG 2>&1 && found="yes"
701       local BASE="$BASE $basename"
702     done
703     if [ -n "$found" ] ; then
704       einfo "$BASE"  ; eend 0
705     else
706       ewarn "(none)" ; eend 1
707     fi
708     if ! [ -S /var/run/acpid.socket ] ; then
709       if ! [ -r /var/run/dbus/pid ] ; then
710         einfo "Starting acpi daemon."
711         /etc/init.d/acpid start >>$DEBUG ; eend $?
712       else
713         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
714         eerror "Solution: please activate acpid via /etc/runlevel.conf"
715         eend 1
716       fi
717     else
718       ewarn "acpi daemon already running."
719       eend 0
720     fi
721     eoutdent
722   fi
723 else
724 # APM
725   if checkbootparam "noapm"; then
726     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
727   else
728     modprobe apm power_off=1 >>$DEBUG 2>&1
729     if [ "$?" = "0" ] ; then
730        if [ -x /etc/init.d/apmd ] ;then
731           einfo "APM Bios found, enabling power management functions."
732           /etc/init.d/apmd start ; eend $?
733        fi
734     else
735       eerror "Loading apm module failed." ; eend 1
736     fi
737   fi
738 fi
739 }
740 # }}}
741
742 # {{{ PCMCIA Check/Setup
743 # This needs to be done before other modules are being loaded (by hwsetup)
744 config_pcmcia(){
745 if checkbootparam "nopcmcia"; then
746   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
747 else
748   if /usr/sbin/laptop-detect ; then
749     einfo "Detected Laptop - checking for PCMCIA." && eend 0
750     modprobe pcmcia_core >>$DEBUG 2>&1
751     # Try Cardbus or normal PCMCIA socket drivers
752     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
753     if [ "$?" = "0" ]; then
754       modprobe ds >>$DEBUG 2>&1
755       if [ -d /proc/bus/pccard ] ; then
756        if [ -x /sbin/cardmgr ] ; then
757         einfo "PCMCIA found, starting cardmgr."
758         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
759        else
760         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
761        fi
762       fi
763     fi
764   fi
765 fi
766 }
767 # }}}
768
769 # {{{ run software synthesizer via speakup
770 config_swspeak(){
771 if checkbootparam swspeak ; then
772  if [ -d /proc/speakup/ ] ; then
773   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
774   eindent
775    if [ -x /etc/init.d/speech-dispatcher ] ; then
776      einfo "Starting speech-dispatcher."
777      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
778      einfo "Activating sftsyn in Kernel."
779      echo sftsyn >/proc/speakup/synth_name ; eend $?
780      einfo "Just run swspeak if you want to use software synthesizer via speakup."
781      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
782    else
783     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
784     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
785    fi
786   eoutdent
787  else
788   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
789   flite -o play -t "Kernel does not seem to support speakup. Sorry."
790  fi
791 fi
792 }
793 # }}}
794
795 # {{{ Check for blind option or brltty
796 config_blind(){
797 BLIND=""
798 checkbootparam "blind" && BLIND="yes"
799 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
800
801 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
802   if [ -x /sbin/brltty ]; then
803     # Blind option detected, start brltty now.
804     # modprobe serial_core parport_serial generic_serial && echo "done"
805     CMD=brltty
806     BRLTYPE=""
807     BRLDEV=""
808     BRLTEXT=""
809     if [ -n "$BRLTTY" ]; then
810       # Extra options
811       BRLTYPE="${BRLTTY%%,*}"
812       R="${BRLTTY#*,}"
813       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
814         BRLTTY="$R"
815         BRLDEV="${BRLTTY%%,*}"
816         R="${BRLTTY#*,}"
817         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
818           BRLTTY="$R"
819           BRLTEXT="${BRLTTY%%,*}"
820           R="${BRLTTY#*,}"
821         fi
822       fi
823     fi
824     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
825     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
826     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
827     einfo "Starting braille-display manager."
828 #    ( exec $CMD & )
829     ( sh -c "$CMD" & )
830     sleep 2 && BLINDSOUND="yes"
831     eend 0
832   fi
833 fi
834 }
835 # }}}
836
837 # {{{ Interactive configuration
838 config_interactive(){
839 if [ -n "$INTERACTIVE" ] ; then
840 einfo "Entering interactive configuration second stage."
841
842   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
843   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
844   read a
845   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
846
847   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
848   read a
849   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
850
851   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
852   read a
853   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
854   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
855 fi
856 eend 0
857 }
858 # }}}
859
860 # {{{ AGP
861 config_agp(){
862 if checkbootparam forceagp ; then
863 # Probe for AGP. Hope this can fail safely
864   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
865 fi
866 }
867 # }}}
868
869 # {{{ automount(er)
870 config_automounter(){
871 if checkbootparam automounter ; then
872   RUNLEVEL="$(runlevel)"
873   AUTOMOUNTER=""
874   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
875
876 addautomount(){
877 # /dev/ice  options
878   d="${1##*/}"
879   if [ -n "$AUTOMOUNTER" ]; then
880     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
881     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
882     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
883     anew="$d        -fstype=auto,$2 :$i"
884     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
885     AUTOMOUNTS="$AUTOMOUNTS $d"
886     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
887   else
888     [ -d /mnt/$d ] && mkdir -p /mnt/$d
889     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
890   fi
891   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
892 }
893
894   AUTOMOUNTS="floppy cdrom"
895 # Add new devices to /etc/fstab and /etc/auto.mnt
896   for i in /dev/cdrom?*; do
897     if [ -L $i ]; then
898       addautomount "$i" "ro"
899     fi
900   done
901 fi
902
903 if [ -n "$AUTOMOUNTER" ]; then
904 # Check for floppy dir, reinstall with automounter
905   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
906   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
907   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
908   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
909   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
910   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
911   rm -f /etc/fstab.new
912 # Replace paths from bootfloppy
913   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
914   mv -f /etc/fstab.new /etc/fstab
915 # Start automounter now
916   einfo "Starting automounter for ${AUTOMOUNTS}."
917   /etc/init.d/autofs start >>$DEBUG ; eend $?
918 fi
919 }
920 # }}}
921
922 # {{{ Collect partitions from /proc/partitions first for enabling DMA
923 check_partitions(){
924 partitions=""
925 IDEDISKS=""
926 while read major minor blocks partition relax; do
927   partition="${partition##*/}"
928   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
929   case "$partition" in
930     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
931     sd?) ;;                                               # SCSI Harddisk, entire disk
932 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
933     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
934   esac
935 done <<EOT
936 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
937 EOT
938 }
939 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
940 # }}}
941
942 # {{{ Enable DMA for all IDE drives now if not disabled
943 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
944 config_dma(){
945 if checkbootparam "nodma"; then
946   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
947 else
948   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
949     if test -d /proc/ide/$d; then
950       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
951         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
952         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
953         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
954         echo "using_dma:1" >/proc/ide/$d/settings
955         eend 0
956       fi
957     fi
958   done
959 fi
960 }
961 # }}}
962
963 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
964 config_fstab(){
965
966 NOSWAP="yes" # we do not use swap by default!
967 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
968    NOSWAP=''
969 fi
970
971 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
972   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
973 else
974   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
975   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
976   iszsh && setopt nonomatch
977   if [ -x /usr/sbin/rebuildfstab ] ; then
978     config_userfstab || fstabuser=grml
979     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
980   else
981     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
982   fi
983   if [ -e /var/run/rebuildfstab.pid ]; then
984     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
985     sleep 8
986   fi
987 fi
988 # Scan for swap, config, homedir
989 if [ -z "$NOSWAP" ]; then
990    einfo "Searching for swap partition(s) as requested."
991 fi
992 GRML_IMG=""
993 GRML_SWP=""
994 HOMEDIR="$(getbootparam home)"
995 if [ -n "$partitions" ]; then
996  while read p m f relax; do
997   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
998   partoptions="users,exec"
999   fnew=""
1000   case "$f" in swap)
1001    eindent
1002    if [ -n "$NOSWAP" ]; then
1003       if [ -z "$INSTALLED" ] ; then
1004          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
1005       fi
1006    else
1007      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1008              S1SUSP|S2SUSP|pmdisk|[zZ]*)
1009                 if [ -n "$ANYSWAP" ] ; then
1010                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1011                   swapon $p 2>>$DEBUG ; eend $?
1012                 else
1013                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1014                 fi
1015                ;;
1016              *)
1017                 if [[ "$p" == LABEL* ]] ; then
1018                    p=$(blkid -t $p | awk -F: '{print $1}')
1019                 fi
1020                 if grep -q $p /proc/swaps ; then
1021                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1022                 else
1023                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1024                    swapon $p 2>>$DEBUG ; eend $?
1025                 fi
1026                ;;
1027      esac
1028    fi
1029    eoutdent
1030    continue
1031    ;;
1032   esac
1033 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1034 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1035 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1036 #  [ -d "$m" ] || mkdir -p "$m"
1037 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1038   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1039   MOUNTOPTS="ro"
1040   case "$f" in
1041     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1042     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1043     *) continue ;;
1044     # *) NONEFOUND='1'; continue ;;
1045   esac
1046   if [ -z "$NOSWAP" ] ; then
1047      mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1048      # Activate swapfile, if exists
1049      SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1050   fi
1051   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1052    mount -o remount,rw $m
1053    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1054     einfo "Using GRML swapfile ${SWAPFILE}."
1055     fnew="$SWAPFILE swap swap defaults 0 0"
1056     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1057     GRML_SWP="$GRML_SWP $SWAPFILE"
1058     eend 0
1059    fi
1060    mount -o remount,ro $m 2>>$DEBUG
1061   fi
1062   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1063   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1064    if [ -n "$HOMEDIR" ]; then
1065     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1066      continue
1067     fi
1068    fi
1069    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1070     GRML_IMG="$IMAGE"
1071     mount -o remount,ro $m 2>>$DEBUG
1072    fi
1073   fi
1074   eend 0
1075   # Umount, if not in use
1076   umount -r $m 2>/dev/null
1077  done <<EOT
1078 $(cat /etc/fstab)
1079 EOT
1080 fi
1081 }
1082 # }}}
1083
1084 # {{{ Mouse
1085 config_mouse(){
1086 if [ -n "$MOUSE_DEVICE" ] ; then
1087   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1088 fi
1089 }
1090 # }}}
1091
1092 # {{{ IPv6 configuration
1093 # Load IPv6 kernel module and print IP adresses
1094 config_ipv6(){
1095 if checkbootparam "ipv6"; then
1096   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1097   modprobe ipv6
1098   # we probably need some time until stateless autoconfiguration has happened
1099   sleep 2
1100   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1101   for DEVICE in `echo "$NETDEVICES"`; do
1102     eindent
1103       einfo "$DEVICE:"
1104       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1105       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1106       eindent
1107         for ADDR in `echo "$ADDRESSES"` ; do
1108             einfo "$ADDR"
1109         done
1110         if [ "$COUNT" -eq "0" ] ; then
1111            einfo "(none)" ; eend 1
1112         fi
1113       eoutdent
1114     eoutdent
1115   done
1116   eend 0
1117 fi
1118 }
1119 # }}}
1120
1121 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1122 config_dhcp(){
1123 if checkbootparam "nodhcp"; then
1124   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1125 else
1126   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1127   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1128   for DEVICE in `echo "$NETDEVICES"` ; do
1129     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1130     trap 2 3 11
1131     ifconfig $DEVICE up >>$DEBUG 2>&1
1132     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1133     trap "" 2 3 11
1134     sleep 1
1135     eend 0
1136   done
1137 fi
1138 }
1139 # }}}
1140
1141 # {{{ helper functions
1142 findfile(){
1143 FOUND=""
1144 # search all partitions for a file in the root directory
1145 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1146 # See if it's already mounted
1147   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1148   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1149     [ -f "$i/$1" ] && FOUND="$i/$1"
1150     umount -l "$i" 2>>$DEBUG
1151     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1152   fi
1153 done
1154 return 2
1155 }
1156
1157 fstype(){
1158 case "$(file -s $1)" in
1159   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1160   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1161   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1162   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1163   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1164   *data*)          echo "invalid"; return 0;;
1165   *) echo "auto"; return 0;;
1166 esac
1167 }
1168
1169 # Try to mount this filesystem read-only, without or with encryption
1170 trymount(){
1171 # Check if already mounted
1172 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1173 # Apparently, mount-aes DOES autodetect AES loopback files.
1174 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1175 # We need to mount crypto-loop files with initial rw support
1176 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1177 # Mount succeeded?
1178 [ "$RC" = "0" ] && return 0
1179 echo ""
1180 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1181 a="y"
1182 while [ "$a" != "n" -a "$a" != "N" ]; do
1183 # We need to mount crypto-loop files with initial rw support
1184  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1185  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1186  # Problem with ioctl() from getpasswd()?
1187  # read a
1188  read a
1189 done
1190 return 1
1191 }
1192 # }}}
1193
1194 # {{{ CPU-detection
1195 config_cpu(){
1196 if checkbootparam "nocpu"; then
1197   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1198 else
1199   if ! [ -x /etc/init.d/powernowd ] ; then
1200     ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
1201   elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
1202     ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
1203   else
1204     if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1205       einfo "Detecting CPU:"
1206       CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1207       echo $CPU | sed 's/ \{1,\}/ /g'
1208       eend 0
1209     else
1210       einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1211     fi
1212     if /usr/sbin/laptop-detect ; then
1213     einfo "Detected Laptop - trying to use cpu frequency scaling:"
1214 #      loadcpumod() {
1215 #      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
1216 #    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
1217 #        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
1218 #      done
1219 #      }
1220 #    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
1221 #    eindent
1222 #    if [[ $CPU = *Intel* ]] ; then
1223 #      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
1224 #      local DETECTED=1
1225 #      loadcpumod
1226 #      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
1227 #    fi
1228 #    if [[ $CPU = *AMD* ]] ; then
1229 #      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
1230 #      local DETECTED=1
1231 #      loadcpumod
1232 #      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1233 #    fi
1234
1235      eindent
1236      if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1237        . /usr/bin/cpufreq-detect.sh
1238        if [ -n "$MODULE" -a "$MODULE" != none ]; then
1239          einfo "Loading module ${MODULE} and starting powernowd."
1240          modprobe cpufreq_userspace 1>>$DEBUG
1241          modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1242          /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1243        else
1244          ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
1245        fi
1246      fi
1247      eoutdent
1248    fi
1249   fi
1250 fi
1251 }
1252 # }}}
1253
1254 # {{{ autostart of ssh
1255 config_ssh(){
1256 if checkbootparam ssh ; then
1257   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1258   einfo "Bootoption passwd found."
1259   if [ -n "$SSH_PASSWD" ] ; then
1260     echo "grml:$SSH_PASSWD" | chpasswd -m
1261     einfo "Starting secure shell server in background."
1262     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1263     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1264     eend 0
1265   else
1266     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1267   fi
1268   eindent
1269     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1270   eoutdent
1271 fi
1272 }
1273 # }}}
1274
1275 # {{{ set password for user grml
1276 config_passwd(){
1277 if checkbootparam passwd >>$DEBUG 2>&1; then
1278   einfo "Bootoption passwd found."
1279   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1280   if [ -n "$PASSWD" ] ; then
1281     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1282   else
1283     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1284   fi
1285   eindent
1286     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1287   eoutdent
1288 fi
1289 }
1290 # }}}
1291
1292 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1293 config_homedir(){
1294 if checkbootparam home ; then
1295 HOMEDIR="$(getbootparam home)"
1296 MYHOMEDEVICE=""
1297 MYHOMEMOUNTPOINT=""
1298 MYHOMEDIR=""
1299 if [ -n "$HOMEDIR" ]; then
1300   einfo "Bootoption home detected." && eend 0
1301   case "$HOMEDIR" in
1302     /dev/*)
1303     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1304     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1305     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1306     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1307   ;;
1308     /mnt/*)
1309     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1310     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1311     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1312     MYHOMEDIR="$HOMEDIR"
1313   ;;
1314     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1315     MYHOMEDIR="$(findfile grml.img)"
1316     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1317     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1318     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1319   ;;
1320   *)
1321     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1322     eerror "Option ignored." ; eend 1
1323   ;;
1324   esac
1325 fi
1326
1327 if [ -n "$MYHOMEDIR" ]; then
1328   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1329     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1330     while read device mountpoint fs relax; do
1331       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1332         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1333           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1334           break
1335         ;;
1336         *[Ff][Aa][Tt]*)
1337         # Note: This currently won't work with encrypted partitions
1338         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1339         if [ ! -f "$MYHOMEDIR" ]; then
1340           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1341           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1342         fi
1343         ;;
1344       esac
1345       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1346         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1347         if [ -f "$MYHOMEDIR" ]; then
1348           # It's a loopback file, mount it over the /home/grml directory
1349           trymount "$MYHOMEDIR" /home/grml
1350           RC="$?"
1351           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1352           RC="$?"
1353         else
1354           # Do a --bind mount
1355           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1356           RC="$?"
1357         fi
1358         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1359       fi
1360       break
1361       ;;
1362     esac
1363   done <<EOT
1364 $(cat /proc/mounts)
1365 EOT
1366   fi
1367 fi
1368 fi # checkbootparam home
1369 }
1370 # }}}
1371
1372 # {{{ Check for scripts on CD-ROM
1373 config_cdrom_scripts(){
1374 if checkbootparam "script"; then
1375   for script in /cdrom/scripts/* ; do
1376     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1377     . $script
1378   done
1379 fi
1380 }
1381 # }}}
1382
1383 # {{{ Sound
1384 config_mixer(){
1385 if ! [ -x /usr/bin/aumix ] ; then
1386   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1387 else
1388
1389   if checkbootparam vol ; then
1390     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1391     if [ -z "$VOL" ] ; then
1392       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1393       VOL='75' # default
1394     fi
1395   else
1396     VOL='75' # default
1397   fi
1398
1399   if checkbootparam nosound ; then
1400     einfo "Muting sound devices on request."
1401     # some IBM notebooks require the following stuff:
1402     if [ -x /usr/bin/amixer ] ; then
1403        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1404           amixer set Front unmute 1>/dev/null
1405           amixer set Front 0% 1>/dev/null
1406        fi
1407     fi
1408     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1409     if [ -n "$ERROR" ] ; then
1410        eindent
1411        eerror "Problem muting sound devices: $ERROR"
1412        eoutdent
1413     fi
1414     eend $RC
1415   elif [ -z "$INSTALLED" ]; then
1416       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1417       # some IBM notebooks require the following stuff:
1418       if [ -x /usr/bin/amixer ] ; then
1419          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1420             amixer set Front unmute 1>/dev/null
1421             amixer set Front ${VOL}% 1>/dev/null
1422          fi
1423       fi
1424       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1425       if [ -n "$ERROR" ] ; then
1426          eindent
1427          eerror "Problem setting mixer volumes: $ERROR"
1428          eoutdent
1429       fi
1430       eend $RC
1431   fi
1432
1433 fi
1434 }
1435 # }}}
1436
1437 # {{{ modem detection
1438 config_modem(){
1439 if checkbootparam "nomodem"; then
1440   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1441 else
1442   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1443    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1444      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1445      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1446      eend 0
1447    fi
1448   fi
1449 fi
1450 }
1451 # }}}
1452
1453 # {{{ keyboard add-ons
1454 config_setkeycodes(){
1455 if checkbootparam "setkeycodes" ; then
1456  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1457   # MS MM keyboard add-on
1458   # fix
1459   setkeycodes e001 126 &>/dev/null
1460   setkeycodes e059 127 &>/dev/null
1461   # fn keys
1462   setkeycodes e03b 59 &>/dev/null
1463   setkeycodes e008 60 &>/dev/null
1464   setkeycodes e007 61 &>/dev/null
1465   setkeycodes e03e 62 &>/dev/null
1466   setkeycodes e03f 63 &>/dev/null
1467   setkeycodes e040 64 &>/dev/null
1468   setkeycodes e041 65 &>/dev/null
1469   setkeycodes e042 66 &>/dev/null
1470   setkeycodes e043 67 &>/dev/null
1471   setkeycodes e023 68 &>/dev/null
1472   setkeycodes e057 87 &>/dev/null
1473   setkeycodes e058 88 &>/dev/null
1474   # hp keycodes
1475   setkeycodes e00a 89 e008 90 &>/dev/null
1476  eend 0
1477 fi
1478 }
1479 # }}}
1480
1481 # {{{ wondershaper
1482 config_wondershaper(){
1483  if checkbootparam "wondershaper" ; then
1484     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1485     CMD=wondershaper
1486     DEVICE=""
1487     DOWNSTREAM=""
1488     UPSTREAM=""
1489     if [ -n "$WONDER" ]; then
1490       # Extra options
1491       DEVICE="${WONDER%%,*}"
1492       R="${WONDER#*,}"
1493       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1494         WONDER="$R"
1495         DOWNSTREAM="${WONDER%%,*}"
1496         R="${WONDER#*,}"
1497         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1498           WONDER="$R"
1499           UPSTREAM="${WONDER%%,*}"
1500           R="${WONDER#*,}"
1501         fi
1502       fi
1503     fi
1504     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1505     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1506     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1507     einfo "Starting wondershaper (${CMD}) in background."
1508     ( sh -c $CMD & ) && eend 0
1509  fi
1510 }
1511 # }}}
1512
1513 # {{{ syslog-ng
1514 config_syslog(){
1515  if checkbootparam "nosyslog"; then
1516   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1517  else
1518   einfo "Starting syslog-ng in background."
1519   /etc/init.d/syslog-ng start 1>>$DEBUG &
1520   eend 0
1521  fi
1522 }
1523 # }}}
1524
1525 # {{{ gpm
1526 config_gpm(){
1527  if checkbootparam "nogpm"; then
1528   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1529  else
1530   einfo "Starting gpm in background."
1531 #  /etc/init.d/gpm start 1>>$DEBUG &
1532   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1533   eend 0
1534  fi
1535 }
1536 # }}}
1537
1538 # {{{ services
1539 config_services(){
1540  if checkbootparam "services" ; then
1541     SERVICE="$(getbootparam services 2>>$DEBUG)"
1542     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1543     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1544     einfo "Starting service(s) ${SERVICENL} in background."
1545     for service in $(echo -e $SERVICELIST) ; do
1546        /etc/init.d/${service} start 1>>$DEBUG &
1547     done
1548     [ "$?" == "0" ] ; eend $?
1549  fi
1550 }
1551 # }}}
1552
1553 # {{{ config files
1554 config_netconfig(){
1555  if checkbootparam netconfig ; then
1556   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1557   CONFIGFILE='/tmp/netconfig.grml'
1558
1559   getconfig() {
1560   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1561        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1562   }
1563   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1564   counter=10
1565   while ! getconfig && [[ "$counter" != 0 ]] ; do
1566     echo -n "Sleeping for 5 seconds and trying to get config again... "
1567     counter=$(( counter-1 ))
1568     echo "$counter tries left" ; sleep 1
1569   done
1570   if [ -r "$CONFIGFILE" ] ; then
1571     einfo "Downloading was successfull." ; eend 0
1572     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1573     md5sum $CONFIGFILE ; eend 0
1574     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1575   else
1576     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1577   fi
1578  fi
1579 }
1580 # }}}
1581
1582 # {{{ blindsound
1583 config_blindsound(){
1584  if checkbootparam "blind" ; then
1585     beep
1586     flite -o play -t "welcome to the gremel system"
1587  fi
1588 }
1589 # }}}
1590
1591 # {{{ welcome sound
1592 config_welcome(){
1593  if checkbootparam welcome ; then
1594   flite -o play -t "welcome to the gremel system"
1595  fi
1596 }
1597 # }}}
1598
1599 # {{{ fix/workaround for unionfs
1600 fix_unionfs(){
1601   if [ -z "$INSTALLED" ]; then
1602    touch /var/cache/apt/*cache.bin
1603   fi
1604 }
1605 # }}}
1606
1607 # {{{ create all /mnt-directories
1608 create_mnt_dirs(){
1609   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1610   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1611 }
1612 # }}}
1613
1614 # {{{ start X window system via grml-x
1615 config_x_startup(){
1616 if checkbootparam startx ; then
1617  if [ -x /usr/X11R6/bin/X ] ; then
1618   if [ -z "$INSTALLED" ] ; then
1619    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1620    if [ -z "$WINDOWMANAGER" ] ; then
1621      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1622      WINDOWMANAGER="wm-ng"
1623    else
1624      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1625    fi
1626    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1627    config_userfstab || fstabuser='grml'
1628  cat>|/etc/init.d/xstartup<<EOF
1629 #!/bin/sh
1630 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1631 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1632 EOF
1633    chmod 755 /etc/init.d/xstartup
1634
1635    sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
1636    
1637    /sbin/telinit q ; eend $?
1638
1639    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1640       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1641    else
1642       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1643    fi
1644
1645   else
1646     eerror "We are not running from CD - startx will not work, skipping it.
1647      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1648   fi
1649  else
1650    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1651    Boot parameter startx does not work therefore." ; eend 1
1652  fi
1653 fi
1654 }
1655 # }}}
1656
1657 # {{{ configuration framework
1658 config_extract(){
1659 if checkbootparam extract ; then
1660  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1661  EXTRACTOPTIONS="-- -x $EXTRACT"
1662 fi
1663 }
1664
1665 config_automount(){
1666 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1667   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1668 else
1669  if [ -z "$INSTALLED" ] ; then
1670   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1671   eindent
1672   [ -d /mnt/grml ] || mkdir /mnt/grml
1673   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1674 # We do need the following fix so floppy disk is available to blkid in any case :-/
1675   if [ -r /dev/fd0 ] ; then
1676      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1677 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1678      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1679         blkid /dev/fd0 1>>$DEBUG 2>&1
1680      fi
1681   fi
1682   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1683   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1684   if [[ $RC == 0 ]]; then
1685     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1686
1687     CONFIG=''
1688     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1689     if [ -n "$CONFIG" ]; then
1690       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1691       cd /
1692       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1693     else
1694       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1695     fi
1696
1697     SCRIPT=''
1698     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1699     if [ -n "$SCRIPT" ]; then
1700       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1701       $SCRIPT ; eend $?
1702     fi
1703     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1704   else
1705     ewarn "No devices with label GRMLCFG found." ; eend 0
1706   fi
1707   eoutdent
1708  fi
1709 fi
1710 }
1711
1712 config_myconfig(){
1713
1714 if checkbootparam "config" ; then
1715   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1716   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1717   einfo "Bootoption config found. config is set to: $CONFIG"
1718   eindent
1719     einfo "Trying to extract configuration file ${CONFIG}:"
1720     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1721   eoutdent
1722 fi
1723
1724 if checkbootparam myconfig ; then
1725  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1726  if [ -n "$MOUNTDEVICE" ]; then
1727    if checkbootparam file ; then
1728     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1729     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1730    fi
1731    [ -d /mnt/grml ] || mkdir /mnt/grml
1732    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1733    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1734     if [[ $RC == 0 ]]; then
1735       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1736       eindent
1737       CONFIG=''
1738       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1739       if [ -n "$CONFIG" ]; then
1740         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1741         cd /
1742         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1743       else
1744         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1745       fi
1746
1747       SCRIPT=''
1748       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1749       if [ -n "$SCRIPT" ]; then
1750         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1751         $SCRIPT ; eend $?
1752       fi
1753       eoutdent
1754     else
1755       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1756     fi # mount $MOUNTDEVICE
1757    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1758  else
1759    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1760  fi # [ -n "$MOUNTDEVICE" ]
1761 fi # checkbootparam myconfig
1762
1763 if checkbootparam "partconf" ; then
1764  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1765  if [ -n "$MOUNTDEVICE" ]; then
1766    [ -d /mnt/grml ] || mkdir /mnt/grml
1767    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1768     if [[ $RC == 0 ]]; then
1769       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1770       einfo "Copying files from $MOUNTDEVICE over grml system."
1771       for file in `cat /etc/grml/partconf` ; do
1772         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1773         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1774       done && eend 0
1775     else
1776       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1777     fi # mount $MOUNTDEVICE
1778    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1779  else
1780    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1781  fi # [ -n "$MOUNTDEVICE" ]
1782 fi
1783 }
1784 # }}}
1785
1786 # {{{ /cdrom/.*-options
1787 config_debs(){
1788 if checkbootparam "debs" ; then
1789   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1790   einfo "Tring to install debian package(s) ${DEBS}"
1791   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1792 fi
1793 }
1794
1795 config_scripts(){
1796 if checkbootparam "scripts" ; then
1797   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1798   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1799   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1800   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1801 fi
1802 }
1803 # }}}
1804
1805 # {{{ distcc
1806 config_distcc(){
1807 if checkbootparam "distcc" ; then
1808  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1809  if [ -n "$OPTIONS" ]; then
1810     NET=""
1811     INTERFACE=""
1812     if [ -n "$OPTIONS" ]; then
1813       NET="${OPTIONS%%,*}"
1814       R="${OPTIONS#*,}"
1815       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1816         OPTIONS="$R"
1817         INTERFACE="${OPTIONS%%,*}"
1818         R="${OPTIONS#*,}"
1819       fi
1820     fi
1821  fi
1822  CONFIG=/etc/default/distcc
1823  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1824  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1825
1826  if [ -n "$INTERFACE" ] ; then
1827    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1828
1829    counter=10
1830    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1831      counter=$(( counter-1 ))
1832      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1833      sleep 3
1834      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1835    done
1836  fi
1837
1838  if [ -n "$IP" ] ; then
1839    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1840
1841    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1842    eindent
1843     id distccd >/dev/null 2>&1 || \
1844     (
1845       einfo "Creating distcc user" ; \
1846       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1847     )
1848
1849     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1850    /etc/init.d/distcc start 1>/dev/null ; eend $?
1851    eoutdent
1852  else
1853    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1854  fi
1855 fi
1856
1857 if checkbootparam "gcc"; then
1858  GCC="$(getbootparam gcc 2>>$DEBUG)"
1859  eindent
1860  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1861  eoutdent
1862  rm -f /usr/bin/gcc
1863  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1864 fi
1865
1866 if checkbootparam "gpp"; then
1867  GPP="$(getbootparam gpp 2>>$DEBUG)"
1868  eindent
1869   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1870   if [ -x /usr/bin/g++-${GPP} ] ; then
1871      rm -f /usr/bin/g++
1872      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1873   fi
1874   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1875   if [ -x /usr/bin/cpp-${GPP} ] ; then
1876      rm -f /usr/bin/cpp
1877      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1878   fi
1879  eoutdent
1880 fi
1881
1882 }
1883 # }}}
1884
1885 # {{{ load modules
1886 # Notice: use it only on live-cd system, if running from harddisk please
1887 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1888 # in /etc/runlevel.conf
1889 config_modules(){
1890 MODULES_FILE=/etc/grml/modules
1891 if checkbootparam nomodules ; then
1892   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1893 elif [ -z "$INSTALLED" ]; then
1894  if [ -r $MODULES_FILE ] ; then
1895   einfo "Loading modules specified in ${MODULES_FILE}:"
1896   eindent
1897   grep '^[^#]' $MODULES_FILE | \
1898   while read module args; do
1899     [ "$module" ] || continue
1900       einfo "${module}"
1901       modprobe $module $args ; eend $?
1902   done
1903   eoutdent
1904  else
1905   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1906  fi
1907 fi
1908 }
1909 # }}}
1910
1911 # {{{ 915resolution
1912 config_915resolution(){
1913 if checkbootparam "915resolution" ; then
1914  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1915   if [ -x /usr/sbin/915resolution ]; then
1916     CMD=915resolution
1917     MODE=""
1918     XRESO=""
1919     YRESO=""
1920     if [ -n "$OPTIONS" ]; then
1921       # Extra options
1922       MODE="${OPTIONS%%,*}"
1923       R="${OPTIONS#*,}"
1924       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1925         OPTIONS="$R"
1926         XRESO="${OPTIONS%%,*}"
1927         R="${OPTIONS#*,}"
1928         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1929           OPTIONS="$R"
1930           YRESO="${OPTIONS%%,*}"
1931           R="${OPTIONS#*,}"
1932         fi
1933       fi
1934     fi
1935     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1936     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1937     eend 0
1938   fi
1939 fi
1940 }
1941 # }}}
1942
1943 # {{{ SW-RAID
1944 config_swraid(){
1945   if [ -z "$INSTALLED" ] ; then
1946   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1947   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1948      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1949      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1950   else
1951     if ! [ -x /sbin/mdadm ] ; then
1952        eerror "mdadm not available, can not execute it." ; eend 1
1953     else
1954
1955        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1956        # find out whether we have a valid configuration file already
1957        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1958           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1959           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1960           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1961         else
1962           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1963        fi
1964
1965        if ! checkbootparam 'swraid' ; then
1966           eindent
1967           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1968           eoutdent
1969        else
1970           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1971           eindent
1972            IFSOLD=${IFS:-}
1973            IFS='
1974 '
1975            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1976                case $line in
1977                  *'No arrays found'*)
1978                    ewarn "$line" ; eend 0
1979                    ;;
1980                  *)
1981                    einfo "$line" ; eend 0
1982                    ;;
1983                esac
1984            done
1985            IFS=$IFSOLD
1986          eoutdent
1987
1988          if [ -r /proc/mdstat ] ; then
1989             eindent
1990             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
1991             if [ -z "$MDSTAT" ] ; then
1992                ewarn "No active arrays found" ; eend 0
1993             else
1994                IFSOLD=${IFS:-}
1995                IFS='
1996 '
1997                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
1998                    einfo "active arrays: $line" ; eend 0
1999                done
2000                IFS=$IFSOLD
2001             fi
2002             eoutdent
2003          fi # /proc/mdstat
2004        fi # bootoption swraid
2005
2006      fi # is /sbin/mdadm executable?
2007   fi # check for bootoptions
2008   fi # run only in live-cd mode
2009 }
2010 # }}}
2011
2012 # {{{ debnet: setup network based on an existing one found on a partition
2013 config_debnet(){
2014 if checkbootparam "debnet" ; then
2015  iszsh && setopt shwordsplit
2016  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2017  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2018  FOUND_DEBNET=""
2019
2020  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2021  eindent
2022  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2023     for i in $DEVICES; do
2024      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2025          einfo "Scanning on $i"
2026        if [ -f /mnt/etc/network/interfaces ]; then
2027          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2028          FOUND_DEBNET="$i"
2029          break
2030        fi
2031        umount /mnt
2032      fi
2033     done
2034
2035    if [ -n "$FOUND_DEBNET" ]; then
2036      einfo "Stopping network."
2037        pump -k 1>/dev/null 2>&1
2038        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2039      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2040        rm -rf /etc/network/run
2041        cp -a /mnt/etc/network /etc
2042        rm -rf /etc/network/run
2043        mkdir /etc/network/run
2044        umount /mnt ; eend $?
2045      einfo "Starting network."
2046        /etc/init.d/networking start ; eend $?
2047    else
2048      eerror "/etc/network/interfaces not found." ; eend 1
2049    fi
2050    eoutdent
2051  else
2052   eerror "Error: /mnt already mounted." ; eend 1
2053  fi
2054 fi
2055 }
2056 # }}}
2057
2058 # {{{ disable console blanking
2059 config_blanking(){
2060 if checkbootparam "noblank" ; then
2061   einfo "Bootoption noblank found. Disabling monitor blanking."
2062   setterm -blank 0 ; eend $?
2063 fi
2064 }
2065 # }}}
2066
2067 # {{{ grml2hd: automatic installation
2068 config_grml2hd(){
2069
2070 if checkbootparam "user" ; then
2071   NEWUSER=''
2072   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2073   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2074 fi
2075
2076 if checkbootparam "filesystem" ; then
2077   FILESYSTEM=''
2078   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2079   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2080 fi
2081
2082 if checkbootparam "partition" ; then
2083   PARTITION=''
2084   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2085   # notice: the following checks whether the given partition is available, if not the skip
2086   # execution of grml2hd as it might result in data loss...
2087   if [ -r $PARTITION ] ; then
2088     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2089   else
2090     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2091   fi
2092 fi
2093
2094 if checkbootparam "mbr" ; then
2095   BOOT_PARTITION=''
2096   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2097   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2098 fi
2099
2100 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2101   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2102 #!/bin/sh
2103 GRML2HD_NONINTERACTIVE='yes' grml2hd
2104 EOF
2105   chmod 755 /usr/bin/grml2hd_noninteractive
2106   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2107   if [ -z "$GRML2HD_FAIL" ] ; then
2108     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2109   else
2110     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2111   fi
2112 fi
2113 }
2114 # }}}
2115
2116 ### {{{ backwards compatible stuff
2117 config_environment(){
2118   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2119 }
2120 config_keyboard(){
2121   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2122 }
2123 # }}}
2124
2125 ## END OF FILE #################################################################
2126 # vim:foldmethod=marker